﻿Imports Infragistics.Win.UltraWinGrid

Public Class Form1


    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        Dim ds As New DataSet()
        Dim t1 As DataTable = ds.Tables.Add("table1")
        t1.Columns.Add("id", GetType(Integer)).AutoIncrement = True
        t1.Columns.Add("Name", GetType(String))
        t1.Columns.Add("Quantity", GetType(Integer))
        t1.Columns.Add("Price", GetType(Double))
        t1.Columns.Add("Date", GetType(DateTime))

        ds.Tables("table1").Rows.Add(New [Object]() {Nothing, "Beverage", 50, 10.2, New DateTime(2008, 4, 22)})
        ds.Tables("table1").Rows.Add(New [Object]() {Nothing, "Appliances", 5, 90, New DateTime(2012, 5, 10)})
        ds.Tables("table1").Rows.Add(New [Object]() {Nothing, "FastFood", 20, 32, New DateTime(2005, 10, 5)})
        ds.Tables("table1").Rows.Add(New [Object]() {Nothing, "Furniture", 12, 79, New DateTime(2009, 2, 28)})
        ds.Tables("table1").Rows.Add(New [Object]() {Nothing, "Meat", 40, 10.2, New DateTime(2008, 4, 22)})
        ds.Tables("table1").Rows.Add(New [Object]() {Nothing, "Fruits", 25, 12, New DateTime(2012, 5, 10)})
        ds.Tables("table1").Rows.Add(New [Object]() {Nothing, "Vegetables", 30, 13, New DateTime(2005, 10, 5)})
        ds.Tables("table1").Rows.Add(New [Object]() {Nothing, "Cars", 13, 200, New DateTime(2009, 2, 28)})
        ds.Tables("table1").Rows.Add(New [Object]() {Nothing, "Tools", 60, 15.3, New DateTime(2008, 4, 22)})
        ds.Tables("table1").Rows.Add(New [Object]() {Nothing, "Estate", 5, 3000, New DateTime(2012, 5, 10)})
        ds.Tables("table1").Rows.Add(New [Object]() {Nothing, "Motorcycles", 10, 320, New DateTime(2005, 10, 5)})
        ds.Tables("table1").Rows.Add(New [Object]() {Nothing, "Clothes", 40, 69, New DateTime(2009, 2, 28)})
        ds.Tables("table1").Rows.Add(New [Object]() {Nothing, "Shoes", 24, 40.6, New DateTime(2008, 4, 22)})
        ds.Tables("table1").Rows.Add(New [Object]() {Nothing, "Games", 53, 50, New DateTime(2012, 5, 10)})
        ds.Tables("table1").Rows.Add(New [Object]() {Nothing, "Books", 42, 22, New DateTime(2005, 10, 5)})
        ds.Tables("table1").Rows.Add(New [Object]() {Nothing, "Movies", 38, 19, New DateTime(2009, 2, 28)})

        UltraGrid1.DataSource = ds

        Dim mappings = UltraGrid1.KeyActionMappings.Cast(Of GridKeyActionMapping)().
            Where(Function(m) (m.KeyCode = Keys.Up Or m.KeyCode = Keys.Down) _
                      And (m.ActionCode = UltraGridAction.AboveCell Or m.ActionCode = UltraGridAction.BelowCell)).ToList()
        For Each mapping In mappings
            UltraGrid1.KeyActionMappings.Remove(mapping)
        Next
    End Sub

    Private Sub UltraGrid1_InitializeLayout(sender As Object, e As Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs)
        With e.Layout.Bands(0).Columns("Price")
            .Format = "#,##0.00;(#,##0.00)"
            .MaskInput = "{LOC}nn,nnn,nnn.nn"
            .PromptChar = ""
        End With

    End Sub

    Private Sub UltraGrid1_KeyDown(sender As Object, e As KeyEventArgs) Handles UltraGrid1.KeyDown
        If (e.KeyCode = Keys.Up) Then
            If UltraGrid1.ActiveRow.Cells("Price").IsActiveCell Then
                If UltraGrid1.ActiveRow.Index >= 1 Then
                    UltraGrid1.Rows(UltraGrid1.ActiveRow.Index - 1).Activate()
                    UltraGrid1.ActiveRow.Cells("Price").Activate()
                    UltraGrid1.PerformAction(UltraGridAction.EnterEditMode)
                End If
            End If
        End If

        If (e.KeyCode = Keys.Down) Then
            If UltraGrid1.ActiveRow.Cells("Price").IsActiveCell Then
                If UltraGrid1.ActiveRow.Index <> UltraGrid1.Rows.Count - 1 Then
                    UltraGrid1.PerformAction(UltraGridAction.NextRow)
                    UltraGrid1.ActiveRow.Cells("Price").Activate()
                    UltraGrid1.PerformAction(UltraGridAction.EnterEditMode)
                End If
            End If
        End If
    End Sub


End Class
